@ECHO off
rem ******************************************************************************************************************************
rem * Licensed Materials - Property of IBM                                                                                       *
rem * (c) Copyright IBM Corp. 2008, 2009 All Rights Reserved.                                                                    *
rem *                                                                                                                            *
rem *US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp*
rem ******************************************************************************************************************************

IF NOT DEFINED LOCALE (SET LOCALE= )
SET LOCEN=0409
SET LOCIT=0410 
SET LOCJP=0411 
SET LOCKO=0412 
SET LOCPO=0415 
SET LOCCHS=0804
SET LOCCHT=0404

IF NOT DEFINED ORA_VERSION (SET ORA_VERSION= )
IF NOT DEFINED ORACLE_HOME (SET ORACLE_HOME= )
IF NOT DEFINED ORACLE_BASE (SET ORACLE_BASE= )
IF NOT DEFINED ORACLE_SID (SET ORACLE_SID= )
IF NOT DEFINED SYSPWD (SET SYSPWD= )
IF NOT DEFINED SYSTEMPWD (SET SYSTEMPWD= )
IF NOT DEFINED SYSMANPWD (SET SYSMANPWD= )
IF NOT DEFINED DBSNMPWD (SET DBSNMPWD= )
IF NOT DEFINED DBA_USER (SET DBA_USER= )
IF NOT DEFINED DBA_PASSWORD (SET DBA_PASSWORD= )
IF NOT DEFINED NF_SCHEMA (SET NF_SCHEMA= )
IF NOT DEFINED STAR_SCHEMA (SET STAR_SCHEMA= )
IF NOT DEFINED REP_USER (SET REP_USER= )
IF NOT DEFINED REP_PASSWD (SET REP_PASSWD= )
IF NOT DEFINED DATA_HOME (SET DATA_HOME= )
IF NOT DEFINED HOST_NAME (SET HOST_NAME= )
IF NOT DEFINED JAVA_HOME (SET JAVA_HOME= )
IF NOT DEFINED ORALEVEL (SET ORALEVEL= )


SET EXITCODE=0
SET MESSAGE= xxx

IF NOT EXIST set_env.bat (
                           SET EXITCODE=4597 
                           GOTO done
                                    ) ELSE (                
                       call set_env.bat
                                  )



IF "%JAVA_HOME%" EQU " " (
SET EXITCODE= 4596 
GOTO done)  


SET CURDIR=%CD%

CD /d "%JAVA_HOME%\bin"
IF "%ERRORLEVEL%" EQU "1" (
SET EXITCODE=4596
GOTO done)

IF NOT EXIST java.exe (
SET EXITCODE= 4598
GOTO done   ) 

CD /d %CURDIR%

set path=%JAVA_HOME%\bin;%path%



REG QUERY "HKCU\Control Panel\International" /v Locale>locale.txt

java com.ibm.rational.vega.dw.SearchAndReplace %LOCIT% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCIT%
SET SQLVARF=ascii/vars_it.sql
call lang\it\messages.bat) 
java com.ibm.rational.vega.dw.SearchAndReplace %LOCJP% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCJP%
SET SQLVARF=ascii/vars_jp.sql
call lang\jp\messages.bat)
java com.ibm.rational.vega.dw.SearchAndReplace %LOCKO% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCKO%
SET SQLVARF=ascii/vars_kr.sql
call lang\kr\messages.bat)
java com.ibm.rational.vega.dw.SearchAndReplace %LOCPO% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCPO%
SET SQLVARF=ascii/vars_pl.sql
call lang\pl\messages.bat)
java com.ibm.rational.vega.dw.SearchAndReplace %LOCCHS% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCCHS%
SET SQLVARF=ascii/vars_zh_CN.sql
call lang\zh_CN\messages.bat)
java com.ibm.rational.vega.dw.SearchAndReplace %LOCCHT% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCCHT%
SET SQLVARF=ascii/vars_zh_TW.sql
call lang\zh_TW\messages.bat)
java com.ibm.rational.vega.dw.SearchAndReplace %LOCEN% locale.txt>nul
IF "%ERRORLEVEL%" EQU "1" (
SET LOCALE=%LOCEN%
SET SQLVARF=ascii/vars_en.sql
call lang\en\messages.bat
)

IF "%LOCALE%" EQU " " (
SET LOCALE=%LOCEN%
SET SQLVARF=vars_en.sql
call lang\en\messages.bat)


IF "%1" EQU "-validate" (GOTO validate)



SET EXITCODE=0
SET MESSAGE=No errors

SET /A SILENT=0
IF "%1" EQU "-silent" (
SET /A SILENT=1) 

SET ORA_CMD=
IF "%1" EQU "-debug" (SET ORA_CMD=ON ) ELSE (SET ORA_CMD=OFF )
IF "%2" NEQ "" (IF "%2" EQU "-debug" (SET ORA_CMD=ON) ELSE (SET ORA_CMD=OFF))


IF %SILENT% EQU 0 (
ECHO %CRREWECH017%
ECHO %CRREWECH018%
)


IF %SILENT% EQU 0 (
SET /P ORA_VERSION=%CRREWPRMPT012%
)
IF "%ORA_VERSION%" EQU " " (
SET MESSAGE=%CRREWMSGE028%
SET EXITCODE=%CRREW4528E%
GOTO done)

IF "%ORA_VERSION%" NEQ "1" (
IF "%ORA_VERSION%" NEQ "2" (
SET MESSAGE=%CRREWMSGE029%
SET EXITCODE=%CRREW4529E%
GOTO done))

IF %SILENT% EQU 0 (
IF "%ORACLE_HOME%" EQU " " (
SET /P ORACLE_HOME=%CRREWPRMPT013%
))
IF "%ORACLE_HOME%" EQU " " (
SET MESSAGE=%CRREWMSGE030%
SET EXITCODE=%CRREW4530E%
GOTO done)

IF NOT EXIST "%ORACLE_HOME%"\bin (
SET MESSAGE=%CRREWMSGE031%
SET EXITCODE=%CRREW4531E%
GOTO done)

IF %SILENT% EQU 0 (
IF "%ORACLE_BASE%" EQU " " (
SET /P ORACLE_BASE=%CRREWPRMPT014%
))
IF "%ORACLE_BASE%" EQU " " (
SET MESSAGE=%CRREWMSGE032%
SET EXITCODE=%CRREW4532E%
GOTO done)

IF NOT EXIST "%ORACLE_BASE%" (
SET MESSAGE=%CRREWMSGE032%
SET EXITCODE=%CRREW4532E%
GOTO done)

IF %SILENT% EQU 0 (
SET /P ORACLE_SID=%CRREWPRMPT015%
)
IF "%ORACLE_SID%" EQU " " ( 
SET MESSAGE=%CRREWMSGE034%
SET EXITCODE=%CRREW4534E%
GOTO done)

IF %SILENT% EQU 0 (
SET /P SYSPWD=%CRREWPRMPT016%
)
IF "%SYSPWD%" EQU " " (
SET MESSAGE=%CRREWMSGE035%
SET EXITCODE=%CRREW4535E%
GOTO done)

IF %SILENT% EQU 0 (
SET /P SYSTEMPWD=%CRREWPRMPT017%
)
IF "%SYSTEMPWD%" EQU " " (
SET MESSAGE=%CRREWMSGE036%
SET EXITCODE=%CRREW4536E%
GOTO done)

IF %SILENT% EQU 0 (
SET /P SYSMANPWD=%CRREWPRMPT018%
)
IF "%SYSMANPWD%" EQU " " (
SET MESSAGE=%CRREWMSGE037%
SET EXITCODE=%CRREW4537E%
GOTO done)

IF %SILENT% EQU 0 (
SET /P DBSNMPWD=%CRREWPRMPT019%
)
IF "%DBSNMPWD%" EQU " " (
SET MESSAGE=%CRREWMSGE038%
SET EXITCODE=%CRREW4538E%
GOTO done)

IF %SILENT% EQU 0 (
SET /P DBA_USER=%CRREWPRMPT020%
)
IF "%DBA_USER%" EQU " " (
SET MESSAGE=%CRREWMSGE039%
SET EXITCODE=%CRREW4539E%
GOTO done)

IF %SILENT% EQU 0 (
SET /P DBA_PASSWORD=%CRREWPRMPT021%
)
IF "%DBA_PASSWORD%" EQU " " (
SET MESSAGE=%CRREWMSGE040%
SET EXITCODE=%CRREW4540E%
GOTO done)

IF %SILENT% EQU 0 (
SET /P NF_SCHEMA=%CRREWPRMPT005%
)
IF "%NF_SCHEMA%" EQU " " (
SET MESSAGE=%CRREWMSGE005%
SET EXITCODE=%CRREW4505E%
GOTO done)

IF %SILENT% EQU 0 (
SET /P STAR_SCHEMA=%CRREWPRMPT006%
)
IF "%STAR_SCHEMA%" EQU " " (
SET MESSAGE=%CRREWMSGE006%
SET EXITCODE=%CRREW4506E%
GOTO done)

IF %SILENT% EQU 0 (
SET /P REP_USER=%CRREWPRMPT007%
)
IF "%REP_USER%" EQU " " (
SET MESSAGE=%CRREWMSGE007%
SET EXITCODE=%CRREW4507E%
GOTO done)

IF %SILENT% EQU 0 (
SET /P REP_PASSWD=%CRREWPRMPT022%
)
IF "%REP_PASSWD%" EQU " " (
SET MESSAGE=%CRREWMSGE044%
SET EXITCODE=%CRREW4544E%
GOTO done)

IF %SILENT% EQU 0 (
SET /P DATA_HOME=%CRREWPRMPT008%
)
IF "%DATA_HOME%" EQU " " (
SET MESSAGE=%CRREWMSGE008%
SET EXITCODE=%CRREW4508E%
GOTO done)


SET HOST_NAME=%COMPUTERNAME%

IF %SILENT% EQU 1 (
SETLOCAL ENABLEDELAYEDEXPANSION
echo CONNECT ^&1^/^&2 >test.sql
echo SELECT COUNT^(*^) FROM CONFIG.ETL_INFO;>>test.sql
echo EXIT SQL.SQLCODE;>>test.sql
sqlplus  /nolog @test.sql '%DBA_USER%' '"%DBA_PASSWORD%"'
IF "!ERRORLEVEL!" EQU "0" (
DEL /Q test.sql
GOTO done)
DEL /Q test.sql
)

IF NOT EXIST work_spc\nul (MKDIR work_spc) ELSE (
RMDIR /S /Q work_spc
MKDIR work_spc
)
IF "%ERRORLEVEL%" NEQ "0" (
SET EXITCODE=%CRREW4576E%
SET MESSAGE=%CRREWMSGE076%
GOTO done)

IF NOT EXIST logs\nul (MKDIR logs) ELSE (
RMDIR /S /Q logs
MKDIR logs
)
IF "%ERRORLEVEL%" NEQ "0" (
SET EXITCODE=%CRREW4576E%
SET MESSAGE=%CRREWMSGE076%
GOTO done)

XCOPY /Y /I /E /Q createDB work_spc\createDB
IF %ERRORLEVEL% GTR 1 ( 
SET MESSAGE=%CRREWMSGE024%
SET EXITCODE=%CRREW4524E%
GOTO done)
XCOPY /Y /I /E /Q ddl work_spc\ddl
IF %ERRORLEVEL% GTR 1 ( 
SET MESSAGE=%CRREWMSGE024%
SET EXITCODE=%CRREW4524E%
GOTO done)
XCOPY /Y /I /E /Q scripts work_spc\scripts
IF %ERRORLEVEL% GTR 1 ( 
SET MESSAGE=%CRREWMSGE024%
SET EXITCODE=%CRREW4524E%
GOTO done)
COPY /Y buildDW.sql work_spc\buildDW.sql
IF %ERRORLEVEL% GTR 0 ( 
SET MESSAGE=%CRREWMSGE024%
SET EXITCODE=%CRREW4524E%
GOTO done)

IF EXIST "%ORACLE_BASE%"\admin\%ORACLE_SID% (
SET MESSAGE=%CRREWMSGE053%
SET EXITCODE=%CRREW4553E% 
ECHO %CRREWECH021%
GOTO done)

IF EXIST "%DATA_HOME%"\oradata\%ORACLE_SID% (
SET MESSAGE=%CRREWMSGE053%
SET EXITCODE=%CRREW4553E% 
ECHO %CRREWECH021%
GOTO done)


ECHO ORACLE_HOME:%ORACLE_HOME%>>logs\createDB.log 
ECHO ORACLE_BASE:%ORACLE_BASE%>>logs\createDB.log
ECHO ORACLE_SID:%ORACLE_SID%>>logs\createDB.log

IF NOT EXIST "%DATA_HOME%"\oradata\%ORACLE_SID%      mkdir "%DATA_HOME%"\oradata\%ORACLE_SID%
IF "%ERRORLEVEL%" NEQ "0" (
SET MESSAGE=%CRREWMSGE058%
SET EXITCODE=%CRREW4558E%
GOTO done)

IF NOT EXIST "%ORACLE_BASE%"\admin\%ORACLE_SID%\adump      mkdir "%ORACLE_BASE%"\admin\%ORACLE_SID%\adump
IF "%ERRORLEVEL%" NEQ "0" (
SET MESSAGE=%CRREWMSGE059%
SET EXITCODE=%CRREW4559E%
GOTO done)
IF NOT EXIST "%ORACLE_BASE%"\admin\%ORACLE_SID%\bdump      mkdir "%ORACLE_BASE%"\admin\%ORACLE_SID%\bdump
IF "%ERRORLEVEL%" NEQ "0" (
SET MESSAGE=%CRREWMSGE060%
SET EXITCODE=%CRREW4560E% 
GOTO done)
IF NOT EXIST "%ORACLE_BASE%"\admin\%ORACLE_SID%\cdump      mkdir "%ORACLE_BASE%"\admin\%ORACLE_SID%\cdump
IF "%ERRORLEVEL%" NEQ "0" (
SET MESSAGE=%CRREWMSGE061%
SET EXITCODE=%CRREW4561E% 
GOTO done)
IF NOT EXIST "%ORACLE_BASE%"\admin\%ORACLE_SID%\dpdump     mkdir "%ORACLE_BASE%"\admin\%ORACLE_SID%\dpdump
IF "%ERRORLEVEL%" NEQ "0" (
SET MESSAGE=%CRREWMSGE062%
SET EXITCODE=%CRREW4562E% 
GOTO done)
IF NOT EXIST "%ORACLE_BASE%"\admin\%ORACLE_SID%\pfile      mkdir "%ORACLE_BASE%"\admin\%ORACLE_SID%\pfile
IF "%ERRORLEVEL%" NEQ "0" (
SET MESSAGE=%CRREWMSGE063%
SET EXITCODE=%CRREW4563E% 
GOTO done)
IF NOT EXIST "%ORACLE_BASE%"\admin\%ORACLE_SID%\udump      mkdir "%ORACLE_BASE%"\admin\%ORACLE_SID%\udump
IF "%ERRORLEVEL%" NEQ "0" (
SET MESSAGE=%CRREWMSGE064%
SET EXITCODE=%CRREW4564E% 
GOTO done)
IF NOT EXIST "%ORACLE_HOME%"\cfgtoollogs\dbca\%ORACLE_SID% mkdir "%ORACLE_HOME%"\cfgtoollogs\dbca\%ORACLE_SID%
IF "%ERRORLEVEL%" NEQ "0" (
SET MESSAGE=%CRREWMSGE065%
SET EXITCODE=%CRREW4565E% 
GOTO done)
IF NOT EXIST "%ORACLE_HOME%"\dbs                      mkdir "%ORACLE_HOME%"\dbs
IF "%ERRORLEVEL%" NEQ "0" (
SET MESSAGE=%CRREWMSGE066%
SET EXITCODE=%CRREW4566E% 
GOTO done)
IF NOT EXIST "%ORACLE_BASE%"\flash_recovery_area      mkdir "%ORACLE_BASE%"\flash_recovery_area
IF "%ERRORLEVEL%" NEQ "0" (
SET MESSAGE=%CRREWMSGE067%
SET EXITCODE=%CRREW4567E% 
GOTO done)
IF NOT EXIST "%ORACLE_BASE%"\oradata\%ORACLE_SID%          mkdir "%ORACLE_BASE%"\oradata\%ORACLE_SID%
IF "%ERRORLEVEL%" NEQ "0" (
SET MESSAGE=%CRREWMSGE068%
SET EXITCODE=%CRREW4568E%  
GOTO done)

FOR /F "TOKENS=3" %%I IN ('sqlplus -v') DO SET ORALEVEL=%%I


IF "%ORALEVEL:~0,5%" NEQ "11.1." (
IF "%ORALEVEL:~0,5%" NEQ "10.2." ( 
IF "%ORALEVEL:~0,5%" NEQ "10.3." ( 
SET ORALEVEL=NONE)
)
)
IF %ORALEVEL% EQU NONE (
SET MESSAGE=%CRREWMSGE029%
SET EXITCODE=%CRREW4529E%
GOTO done)

IF "%ORA_VERSION%" EQU "1" (
call work_spc\createDB\init10.bat
call work_spc\createDB\initTemp10.bat
)
IF "%ORA_VERSION%" EQU "2" (
call work_spc\createDB\init.bat
call work_spc\createDB\initTemp.bat
)
"%ORACLE_HOME%"\bin\oradim.exe -new -sid %ORACLE_SID% -startmode manual -spfile >>logs\createDB.log
IF "%ERRORLEVEL%" NEQ "0" (
SET MESSAGE=%CRREWMSGE069%
SET EXITCODE=%CRREW4569E%
ECHO %CRREWECH003%
GOTO done)

"%ORACLE_HOME%"\bin\oradim.exe -edit -sid %ORACLE_SID% -startmode auto -srvcstart system>logs\createDBService.log
IF "%ERRORLEVEL%" NEQ "0" (
SET MESSAGE=%CRREWMSGE069%
SET EXITCODE=%CRREW4569E%
ECHO %CRREWECH020%
GOTO done)


REM echo %ORACLE_HOME% %ORACLE_SID% '"%CD%"' %sysPassword% '"%ORACLE_BASE%"' %DBA_USER% %DBA_PASSWORD% %NF_SCHEMA% %STAR_SCHEMA% %REP_USER%  %ORA_CMD%
rem "%ORACLE_HOME%"\bin\sqlplus /nolog @"%CD%"\work_spc\createDB\VEGADB.sql '"%ORACLE_HOME%"' %ORACLE_SID% '"%CD%"' %SYSPWD% %SYSTEMPWD% %SYSMANPWD% %DBSNMPWD% '"%ORACLE_BASE%"' %HOST_NAME% %ORA_CMD%
"%ORACLE_HOME%"\bin\sqlplus /nolog @"%CD%"\work_spc\createDB\createDB.sql '"%ORACLE_HOME%"' %ORACLE_SID% '"%CD%"' '"%SYSPWD%"' '"%SYSTEMPWD%"' '"%SYSMANPWD%"' '"%DBSNMPWD%"' '"%ORACLE_BASE%"' %HOST_NAME% %ORA_CMD% %ORA_VERSION% database '"PWD%ORACLE_SID%.ora"'


"%ORACLE_HOME%"\bin\sqlplus /nolog @"%CD%"\work_spc\buildDW.sql '"%ORACLE_HOME%"' %ORACLE_SID% '"%CD%"' '"%SYSPWD%"' '"%ORACLE_BASE%"' %DBA_USER% '"%DBA_PASSWORD%"' %NF_SCHEMA% %STAR_SCHEMA% %REP_USER%  %ORA_CMD% '"%REP_PASSWD%"' '"%DATA_HOME%"' %SQLVARF%

call ora_load.bat %ORACLE_SID% %DBA_USER% "%DBA_PASSWORD%" %NF_SCHEMA% %STAR_SCHEMA%

GOTO done

:validate

SET EXITCODE=0
SET MESSAGE=No errors

IF NOT DEFINED ORA_VERSION (
SET MESSAGE=%CRREWMSGE028%
SET EXITCODE=%CRREW4528E%
GOTO done)

IF "%ORA_VERSION%" NEQ "1" (
IF "%ORA_VERSION%" NEQ "2" (
SET MESSAGE=%CRREWMSGE029%
SET EXITCODE=%CRREW4529E%
GOTO done))


IF NOT DEFINED ORACLE_HOME (
SET ORACLE_HOME
SET MESSAGE=%CRREWMSGE030%
SET EXITCODE=%CRREW4530E%
GOTO done)

IF NOT EXIST "%ORACLE_HOME%"\bin (
SET MESSAGE=%CRREWMSGE031%
SET EXITCODE=%CRREW4531E%
GOTO done)


IF NOT DEFINED ORACLE_BASE (
SET MESSAGE=%CRREWMSGE032%
SET EXITCODE=%CRREW4532E%
GOTO done)

IF NOT EXIST "%ORACLE_BASE%" (
SET MESSAGE=%CRREWMSGE032%
SET EXITCODE=%CRREW4532E%
GOTO done)

IF NOT DEFINED ORACLE_SID (
SET MESSAGE=%CRREWMSGE034%
SET EXITCODE=%CRREW4534E%
GOTO done)

IF NOT DEFINED SYSPWD (
SET MESSAGE=%CRREWMSGE035%
SET EXITCODE=%CRREW4535E%
GOTO done)

IF NOT DEFINED SYSTEMPWD (
SET MESSAGE=%CRREWMSGE036%
SET EXITCODE=%CRREW4536E%
GOTO done)

IF NOT DEFINED SYSMANPWD (
SET MESSAGE=%CRREWMSGE037%
SET EXITCODE=%CRREW4537E%
GOTO done)

IF NOT DEFINED DBSNMPWD (
SET MESSAGE=%CRREWMSGE038%
SET EXITCODE=%CRREW4538E%
GOTO done)

IF NOT DEFINED DBA_USER (
SET MESSAGE=%CRREWMSGE039%
SET EXITCODE=%CRREW4539E%
GOTO done)

IF NOT DEFINED DBA_PASSWORD (
SET MESSAGE=%CRREWMSGE040%
SET EXITCODE=%CRREW4540E%
GOTO done)

IF NOT DEFINED NF_SCHEMA (
SET EXITCODE=%CRREW4505E%
SET MESSAGE=%CRREWMSGE005%
GOTO done)

IF NOT DEFINED STAR_SCHEMA (
SET EXITCODE=%CRREW4506E%
SET MESSAGE=%CRREWMSGE006%
GOTO done)

IF NOT DEFINED REP_USER (
SET EXITCODE=%CRREW4507E%
SET MESSAGE=%CRREWMSGE007%
GOTO done)

IF NOT DEFINED REP_PASSWD (
SET EXITCODE=%CRREW4544E%
SET MESSAGE=%CRREWMSGE044%
GOTO done)

IF NOT DEFINED DATA_HOME (
SET EXITCODE=%CRREW4508E%
SET MESSAGE=%CRREWMSGE008%
GOTO done)

REG QUERY "HKCU\Control Panel\International" /v Locale>nul
IF "%ERRORLEVEL%" NEQ "0" (
SET EXITCODE=%CRREW4585E%
SET MESSAGE=%CRREWMSGE085%
GOTO done
)

IF "%ORA_VERSION%" EQU " " (
SET MESSAGE=%CRREWMSGE028%
SET EXITCODE=%CRREW4528E%
GOTO done)

IF "%ORACLE_HOME%" EQU " " (
SET MESSAGE=%CRREWMSGE030%
SET EXITCODE=%CRREW4530E%
GOTO done)

IF "%ORACLE_BASE%" EQU " " (
SET MESSAGE=%CRREWMSGE032%
SET EXITCODE=%CRREW4532E%
GOTO done)

IF "%ORACLE_SID%" EQU " " ( 
SET MESSAGE=%CRREWMSGE034%
SET EXITCODE=%CRREW4534E%
GOTO done)

IF "%SYSPWD%" EQU " " (
SET MESSAGE=%CRREWMSGE035%
SET EXITCODE=%CRREW4535E%
GOTO done)

IF "%SYSTEMPWD%" EQU " " (
SET MESSAGE=%CRREWMSGE036%
SET EXITCODE=%CRREW4536E%
GOTO done)

IF "%SYSMANPWD%" EQU " " (
SET MESSAGE=%CRREWMSGE037%
SET EXITCODE=%CRREW4537E%
GOTO done)

IF "%DBSNMPWD%" EQU " " (
SET MESSAGE=%CRREWMSGE038%
SET EXITCODE=%CRREW4538E%
GOTO done)

IF "%DBA_USER%" EQU " " (
SET MESSAGE=%CRREWMSGE039%
SET EXITCODE=%CRREW4539E%
GOTO done)

IF "%DBA_PASSWORD%" EQU " " (
SET MESSAGE=%CRREWMSGE040%
SET EXITCODE=%CRREW4540E%
GOTO done)

IF "%NF_SCHEMA%" EQU " " (
SET EXITCODE=%CRREW4505E%
SET MESSAGE=%CRREWMSGE005%
GOTO done)

IF "%STAR_SCHEMA%" EQU " " (
SET EXITCODE=%CRREW4506E%
SET MESSAGE=%CRREWMSGE006%
GOTO done)

IF "%REP_USER%" EQU " " (
SET EXITCODE=%CRREW4507E%
SET MESSAGE=%CRREWMSGE007%
GOTO done)

IF "%REP_PASSWD%" EQU " " (
SET EXITCODE=%CRREW4544E%
SET MESSAGE=%CRREWMSGE044%
GOTO done)

IF "%DATA_HOME%" EQU " " (
SET EXITCODE=%CRREW4508E%
SET MESSAGE=%CRREWMSGE008%
GOTO done)





GOTO done

:done 
echo %MESSAGE%:%EXITCODE%
echo %CRREWECH002%
EXIT /B %EXITCODE%