@echo off
rem ******************************************************************************************************************************
rem * Licensed Materials - Property of IBM                                                                                       *
rem * (c) Copyright IBM Corp. 2008, 2009 All Rights Reserved.                                                                    *
rem *                                                                                                                            *
rem *US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp*
rem ******************************************************************************************************************************

SET NLS_LANG=AMERICAN_AMERICA.UTF8
SET NLS_DATE_FORMAT =YYYY-MM-DD
SET NLS_TIMESTAMP_FORMAT="YYYY-MM-DD HH24:MI:SS.FFFFFF"

IF NOT EXIST implog\nul (MKDIR implog) ELSE (
RMDIR /S /Q implog
MKDIR implog
)
IF "%ERRORLEVEL%" NEQ "0" (
SET EXITCODE=%CRREW4576E%
SET MESSAGE=%CRREWMSGE076%
GOTO done)

IF NOT EXIST controlfiles\nul (MKDIR controlfiles) ELSE (
RMDIR /S /Q controlfiles
MKDIR controlfiles
)
IF "%ERRORLEVEL%" NEQ "0" (
SET EXITCODE=%CRREW4576E%
SET MESSAGE=%CRREWMSGE076%
GOTO done)

IF NOT EXIST badfiles\nul (MKDIR badfiles) ELSE (
RMDIR /S /Q badfiles
MKDIR badfiles
)
IF "%ERRORLEVEL%" NEQ "0" (
SET EXITCODE=%CRREW4576E%
SET MESSAGE=%CRREWMSGE076%
GOTO done)

IF NOT EXIST discardfiles\nul (MKDIR discardfiles) ELSE (
RMDIR /S /Q discardfiles
MKDIR discardfiles
)
IF "%ERRORLEVEL%" NEQ "0" (
SET EXITCODE=%CRREW4576E%
SET MESSAGE=%CRREWMSGE076%
GOTO done)

pushd controlfiles_tmp
set classpath=.;..\;%classpath%
for %%a in (*.ctl) do (
java com.ibm.rational.vega.dw.SearchAndReplace STAR_SCHEMA %5 %%a ..\controlfiles\%%a.1
java com.ibm.rational.vega.dw.SearchAndReplace NF_SCHEMA %4 ..\controlfiles\%%a.1 ..\controlfiles\%%a
del /Q ..\controlfiles\%%a.1
)
popd


set ORACLE_SID=%1
sqlplus %2/%3 @scripts\ora_constr_dis.sql %4 %5
sqlplus %2/%3 @scripts\ora_trig_dis.sql %4 %5

sqlplus %2/%3 @scripts\tmp_disable.sql
sqlplus %2/%3 @scripts\tmp_trig_disable.sql

set LOGF=..\implog
set CURDIR=%CD%
set CONTF=%CD%\controlfiles\
pushd controlfiles
set classpath=.;..\;%classpath%
for %%a in (*.ctl) do (
echo %%a >>..\logs\ora_load.log
sqlldr userid =%2/%3 control=%%a log=%LOGF%\%%a.log errors=100000 direct=yes
java com.ibm.rational.vega.dw.SearchAndReplace ORA %LOGF%\%%a.log>>..\logs\ora_load.log
)
popd

java com.ibm.rational.vega.dw.SearchAndReplace ORA logs\ora_load.log>nul
IF "%ERRORLEVEL%" EQU "1" (
	SET MESSAGE=%CRREWMSGE072%
	SET EXITCODE=%CRREW4572E%
	GOTO done
)

sqlplus %2/%3 @scripts\ora_constr_ena.sql %4 %5
sqlplus %2/%3 @scripts\ora_trig_ena.sql %4 %5
sqlplus %2/%3 @scripts\tmp_enable.sql
java com.ibm.rational.vega.dw.SearchAndReplace ORA- logs\cnstr_enable.log>nul
IF "%ERRORLEVEL%" EQU "1" (
	SET MESSAGE=%CRREWMSGE073%
	SET EXITCODE=%CRREW4573E%
	GOTO done
	)
sqlplus %2/%3 @scripts\tmp_trig_enable.sql
java com.ibm.rational.vega.dw.SearchAndReplace ORA- logs\trig_enable.log>nul
IF "%ERRORLEVEL%" EQU "1" (
	SET MESSAGE=%CRREWMSGE074%
	SET EXITCODE=%CRREW4574E%
	GOTO done
	)
GOTO done
	
:done
echo %MESSAGE%:%EXITCODE%
exit /B %EXITCODE%


