#!/bin/ksh

# ******************************************************************************************************************************
# * Licensed Materials - Property of IBM                                                                                       *
# * (c) Copyright IBM Corp. 2008, 2009 All Rights Reserved.                                                                    *
# *                                                                                                                            *
# *US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp*
# ******************************************************************************************************************************

rcrdone(){
echo $MESSAGE:$EXITCODE
echo $CRREWECH002$
exit $EXITCODE
}

export NLS_LANG=AMERICAN_AMERICA.UTF8
export NLS_DATE_FORMAT=YYYY-MM-DD
#export NLS_TIMESTAMP_FORMAT='YYYY-MM-DD HH24:MI:SS.FFFFFF'

if [ ! -d $CD/implog ]
then
	mkdir -p $CD/implog
else
	rm -fr $CD/implog
	mkdir -p $CD/implog	
fi
if [ $? -ne 0 ]
then
	MESSAGE=$CRREWMSGE076
	EXITCODE=$CRREW4576E
	rcrdone
fi
if [ ! -d $CD/controlfiles ]
then
	mkdir -p $CD/controlfiles
else
	rm -fr $CD/controlfiles
	mkdir -p $CD/controlfiles	
fi
if [ $? -ne 0 ]
then
	MESSAGE=$CRREWMSGE076
	EXITCODE=$CRREW4576E
	rcrdone
fi

if [ ! -d $CD/badfiles ]
then
	mkdir -p $CD/badfiles
else
	rm -fr $CD/badfiles
	mkdir -p $CD/badfiles	
fi
if [ $? -ne 0 ]
then
	MESSAGE=$CRREWMSGE076
	EXITCODE=$CRREW4576E
	rcrdone
fi

if [ ! -d $CD/discardfiles ]
then
	mkdir -p $CD/discardfiles
else
	rm -fr $CD/discardfiles
	mkdir -p $CD/discardfiles	
fi
if [ $? -ne 0 ]
then
	MESSAGE=$CRREWMSGE076
	EXITCODE=$CRREW4576E
	rcrdone
fi

if [ $? -ne 0 ]
then
	MESSAGE=$CRREWMSGE076
	EXITCODE=$CRREW4576E
	rcrdone
fi

cd controlfiles_tmp
ls *.ctl |while read FILE; do 
sed -e "s/STAR_SCHEMA/`echo $5`/g" $FILE|sed -e "s/NF_SCHEMA/`echo $4`/g"|sed -e 's/\\/\//g'>../controlfiles/$FILE
done
cd $CD

ORACLE_SID=$1
sqlplus $2/$3 @scripts/ora_constr_dis.sql $4 $5
sqlplus $2/$3 @scripts/ora_trig_dis.sql $4 $5

sqlplus $2/$3 @scripts/tmp_disable.sql
sqlplus $2/$3 @scripts/tmp_trig_disable.sql

LOGF=$CD/implog
CURDIR=$CD
CONTF=$CD/controlfiles/

cd controlfiles

ls *.ctl |while read FILE; do 
	echo "sqlldr userid =$2/$3 control=$FILE log=$LOGF/$FILE.log errors=100000 direct=yes" >>$CURDIR/logs/ora_load.log
	sqlldr userid =$2/$3 control=$FILE log=$LOGF/$FILE.log errors=100000 direct=yes>>$CURDIR/logs/ora_load.log
	grep -e "ORA" $LOGF/$FILE.log>>$CURDIR/logs/ora_load.log
done

cd $CD

grep -e "ORA" $CURDIR/logs/ora_load.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRREWMSGE072
	EXITCODE=$CRREW4572E
	rcrdone
fi


sqlplus $2/$3 @scripts/ora_constr_ena.sql $4 $5
sqlplus $2/$3 @scripts/ora_trig_ena.sql $4 $5
sqlplus $2/$3 @scripts/tmp_enable.sql

grep -e "ORA" logs/cnstr_enable.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRREWMSGE073
	EXITCODE=$CRREW4573E
	rcrdone
fi

sqlplus $2/$3 @scripts/tmp_trig_enable.sql
grep -e "ORA" logs/trig_enable.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRREWMSGE074
	EXITCODE=$CRREW4574E
	rcrdone
fi
