--******************************************************************************************************************************
--* Licensed Materials - Property of IBM                                                                                       *
--* (c) Copyright IBM Corp. 2008, 2009 All Rights Reserved.                                                                    *
--*                                                                                                                            *
--*US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp*
--******************************************************************************************************************************

ALTER SESSION SET CURRENT_SCHEMA=&&STAR_SCHEMA;


create or replace function WEEKOFYEAR (inputdate in date)
return number
is
first_day_of_year date;
week_number number;
d INTEGER :=0;
p INTEGER :=0;
year_str VARCHAR2(15);
start_date date;
begin
 -- Set up the first day of Year 
 year_str:= rtrim (TO_CHAR(inputdate,'YYYY'));
    start_date:= to_date( year_str || '-' || '01-01','yyyy-mm-dd');
-- Find out first Sunday of week of year start  
select round(trunc(inputdate,'YEAR'),'DAY') into first_day_of_year from dual;

d:=inputdate+1 - first_day_of_year;
 If first_day_of_year<start_date then 
  if d = 0 then
   week_number := abs(inputdate+1 - first_day_of_year)/7 +1;
    end if;
  if d>0 then 
week_number := abs(inputdate+1 - first_day_of_year)/7;
end if;
end if;

If first_day_of_year>start_date then
if d >= 0 then
   week_number := abs(inputdate+1 - first_day_of_year)/7 +1;
    end if;
  if d<0 then 
week_number := abs(inputdate+1 - first_day_of_year)/7;
end if;
end if;
If first_day_of_year=start_date then 
week_number := abs(inputdate+1 - first_day_of_year)/7 ;
end if;
return ceil(week_number);
end;
/

create or replace PROCEDURE POPULATE_D_DATE (START_YEAR IN INTEGER,  END_YEAR IN INTEGER, SCHEMA_NAME CHAR)
IS

	
        v_date_id INTEGER;
        v_date DATE;
        v_year_str CHAR(4);
        v_year INTEGER := 0;
        v_previous_year INTEGER := 0;
        v_quarter_of_year INTEGER := 0;
        v_month_of_year INTEGER := 0;
        v_month_name VARCHAR(20);
        v_week_of_year INTEGER := 0;
        v_week_of_year_iso INTEGER := 0;
        v_quarter_no INTEGER := 0;
        v_month_no INTEGER := 0;
        v_week_no INTEGER := 0;
        v_week_no_iso INTEGER := 0;
        v_week_of_month INTEGER := 0;
        v_week_of_month_iso INTEGER := 0;
        v_day_of_week INTEGER := 0;
        v_day_of_week_iso INTEGER := 0;
        v_day_of_month INTEGER := 0;
        v_day_of_year INTEGER := 0;
        v_day_name VARCHAR(20);
        v_previous_quarter INTEGER := 0;
        v_previous_month INTEGER := 0;
        v_previous_week INTEGER := 0;
        v_previous_week_iso INTEGER := 0;
       -- v_calendar_type INTEGER;
       -- v_calendar_type_c CHAR(1);
        v_schema_name CHAR(8);
        stmt VARCHAR(1000) := '';
        v_print VARCHAR(100);
        v_min_date DATE;
        v_max_date DATE;


  TYPE CR1 IS REF CURSOR;
  C1 CR1;
        
  

BEGIN

	
    --v_calendar_type :=CALENDAR_TYPE;
	--	v_calendar_type_c:= CASE WHEN v_calendar_type=1 THEN 'G' WHEN v_calendar_type=2 THEN 'I' ELSE 'G' END;
		v_schema_name:=UPPER(RTRIM(SCHEMA_NAME));
 

    
		IF START_YEAR IS NULL OR START_YEAR>END_YEAR THEN
		RAISE_APPLICATION_ERROR(-20010,TO_CHAR(VARS_LANG.CRREWMSGE087));
		END IF;

		IF (END_YEAR IS NULL) OR (END_YEAR < START_YEAR) THEN
			RAISE_APPLICATION_ERROR(-20020,TO_CHAR(VARS_LANG.CRREWMSGE088));
		END IF;

	--	IF v_calendar_type<>1 AND v_calendar_type <> 2 THEN
	--			RAISE_APPLICATION_ERROR(-20030,TO_CHAR(VARS_LANG.CRREWMSGE086));
	--	END IF;

		IF (length(rtrim(v_schema_name,''))=0) THEN
		RAISE_APPLICATION_ERROR(-20040,TO_CHAR(VARS_LANG.CRREWMSGE089));
		END IF;



    v_year_str:= rtrim (to_char(START_YEAR));
    v_min_date:= to_date( v_year_str || '-' || '01-01','yyyy-mm-dd');
    v_year_str:= rtrim(to_char(END_YEAR));
    v_max_date:= to_date(v_year_str || '-' || '12-31','yyyy-mm-dd');
    v_previous_year:=START_YEAR;
    v_week_of_month:=1;
    v_day_of_month:=0;

    WHILE(v_min_date<=v_max_date)
    LOOP

	    	 v_year:=to_number(to_char(v_min_date,'yyyy'));
	    	 v_quarter_of_year:=to_number(to_char(v_min_date,'Q'));
	    	 v_month_of_year:=to_number(to_char(v_min_date, 'mm'));
	    	 v_month_name:=to_char(v_min_date,'month');
	    	-- v_week_of_year:=CASE WHEN v_calendar_type=1 THEN to_number(to_char(v_min_date,'ww')) ELSE to_number(to_char(v_min_date,'iw')) END;
	    	 
             
                 v_week_of_year:=WEEKOFYEAR(v_min_date);
              
                 v_week_of_year_iso:=to_number(to_char(v_min_date,'iw'));
           
         
         v_quarter_no:= CASE WHEN v_quarter_of_year<>v_previous_quarter THEN v_quarter_no+1 ELSE v_quarter_no END;
	    	 v_month_no:= CASE WHEN v_month_of_year<> v_previous_month THEN v_month_no+1 ELSE v_month_no END;
	    	 v_week_no:= CASE WHEN v_week_of_year<>v_previous_week THEN v_week_no+1 ELSE v_week_no END;
	    	 v_week_no_iso:= CASE WHEN v_week_of_year_iso<>v_previous_week_iso THEN v_week_no_iso+1 ELSE v_week_no_iso END;
			   --v_day_of_week :=CASE WHEN v_calendar_type=1 then to_number(to_char(v_min_date,'d'))-1 ELSE to_number(to_char(v_min_date,'d')) END;
     --IF v_calendar_type <>1 and to_number(to_char(v_min_date,'d'))=1 THEN
     IF to_number(to_char(v_min_date,'d'))=1 THEN
               v_day_of_week_iso :=to_number(to_char(v_min_date,'d'))+6;
           end if; 
         
            --IF v_calendar_type <>1  and to_number(to_char(v_min_date,'d'))<>1 then
            IF to_number(to_char(v_min_date,'d'))<>1 then
                v_day_of_week_iso :=to_number(to_char(v_min_date,'d'))-1;
           end if;
      
         -- if v_calendar_type =1 then
               v_day_of_week :=to_number(to_char(v_min_date,'d'));
       --end if;
     
         v_day_of_month:=CASE WHEN v_month_of_year<> v_previous_month THEN 1 ELSE v_day_of_month+1 END;
			   v_day_of_year:=to_number(to_char(v_min_date,'ddd'));
			   v_day_name:=to_char(v_min_date,'day');
			
--			IF v_month_of_year<> v_previous_month  THEN
--				IF v_calendar_type=1 THEN
--					 v_week_of_month:=1;
--				ELSIF v_calendar_type=2 THEN
--					IF v_day_of_week<5 THEN
--					 v_week_of_month:=1;
--					ELSE v_week_of_month:=0;
--					END IF;
--				END IF;
--				ELSIF v_day_of_week=1 THEN
--					 v_week_of_month:=v_week_of_month+1;
--			END IF;
           
           IF v_month_of_year<> v_previous_month  THEN
					 v_week_of_month:=1;
					IF v_day_of_week_iso<5 THEN
						v_week_of_month_iso:=1;
					ELSE v_week_of_month_iso:=0;
					END IF;
			ELSE
			   IF v_day_of_week=1 THEN
					v_week_of_month:=v_week_of_month+1;	
			   END IF;
			   IF v_day_of_week_iso=1 THEN
				  v_week_of_month_iso:=v_week_of_month_iso+1;
	           END IF; 
		  END IF;


      BEGIN
      stmt:= 'SELECT ' ||v_schema_name||'.SEQ_D_DATE.NEXTVAL'||' FROM DUAL';

          OPEN c1 FOR stmt;
	            FETCH c1 INTO  v_date_id;
          CLOSE c1;
          EXCEPTION
           WHEN others THEN
             RAISE_APPLICATION_ERROR(-20050,SubStr('Error '||TO_CHAR(SQLCODE)||': '||SQLERRM, 1, 255));
      END;



    stmt:='INSERT INTO ' || v_schema_name || '.D_DATE (DATE_ID,PERIOD_START_DATE,DAY_OF_WEEK ,DAY_OF_MONTH,DAY_OF_YEAR,DAY_NAME,WEEK_OF_MONTH ,WEEK_OF_YEAR,WEEK_NO,MONTH_OF_YEAR,MONTH_NAME,MONTH_NO,QUARTER_OF_YEAR,QUARTER_NO,YEAR_OF,DAY_OF_WEEK_ISO,WEEK_OF_MONTH_ISO,WEEK_OF_YEAR_ISO,WEEK_NO_ISO) VALUES(:1,:2,:3,:4,:5,:6,:7,:8,:9,:10,:11,:12,:13,:14,:15,:16,:17,:18,:19)';

   EXECUTE IMMEDIATE stmt USING v_date_id,v_min_date,v_day_of_week,v_day_of_month,v_day_of_year,v_day_name,v_week_of_month,v_week_of_year,v_week_no,v_month_of_year,v_month_name,v_month_no,v_quarter_of_year,v_quarter_no,v_year,v_day_of_week_iso,v_week_of_month_iso,v_week_of_year_iso,v_week_no_iso;

      		 v_previous_quarter:=v_quarter_of_year;
      		 v_previous_month:=v_month_of_year;
      		 v_previous_week:=v_week_of_year;
      		 v_previous_week_iso:=v_week_of_year_iso;
      		 v_min_date:=v_min_date +1;
 	END LOOP;


 --stmt:= 'UPDATE CONFIG.SYSCONFIG_INFO SET CHAR_VALUE='''|| v_calendar_type_c ||''',INT_VALUE=' || v_calendar_type|| ' WHERE NAME=''CALENDAR_WEEK_TYPE''';
	--EXECUTE IMMEDIATE stmt;

END;
/


create or replace PROCEDURE RECALCULATE_D_DATE( SCHEMA_NAME CHAR)

IS
		 v_total_rows INTEGER;
		 v_week_no INTEGER := 0;
		 v_week_no_iso INTEGER := 0;
		 v_month_no INTEGER := 0;
		 v_quarter_no INTEGER := 0;
                 v_cur_week_no INTEGER := 0;
                 v_cur_week_no_iso INTEGER := 0;
		 v_cur_month_no INTEGER := 0;
		 v_cur_quarter_no INTEGER := 0;
		 v_prev_week_no INTEGER := 0;
		 v_prev_week_no_iso INTEGER := 0;
		 v_prev_month_no INTEGER := 0;
		 v_prev_quarter_no INTEGER := 0;
		-- v_calendar_type INTEGER;
		 v_schema_name CHAR(8);
		 stmt VARCHAR(1000) := ''; 
		 stmt2 VARCHAR(1000) := '';
		 v_cur_date DATE;

		 
    TYPE CR31 IS REF CURSOR;
    CS31 CR31;
 
  BEGIN  
   v_schema_name:=UPPER(RTRIM(SCHEMA_NAME));
	BEGIN
  stmt:='SELECT PERIOD_START_DATE,WEEK_OF_YEAR,WEEK_OF_YEAR_ISO,MONTH_OF_YEAR,QUARTER_OF_YEAR FROM '||v_schema_name||'.D_DATE ORDER BY PERIOD_START_DATE';

  	
 
		
      		OPEN CS31 FOR stmt;
					LOOP
					FETCH CS31 INTO v_cur_date,v_cur_week_no,v_cur_week_no_iso,v_cur_month_no,v_cur_quarter_no;
 
          
          EXIT WHEN CS31%NOTFOUND;
					
				  IF v_cur_week_no<>v_prev_week_no THEN 
					    v_week_no:=v_week_no+1;
					    v_prev_week_no:=v_cur_week_no;
					END IF;
					
				  IF v_cur_week_no_iso<>v_prev_week_no_iso THEN 
					    v_week_no_iso:=v_week_no_iso+1;
					    v_prev_week_no_iso:=v_cur_week_no_iso;
				  END IF;
					
					IF v_cur_month_no<>v_prev_month_no THEN 
					    v_month_no:=v_month_no+1;
					    v_prev_month_no:=v_cur_month_no;
					END IF;
					
					IF v_cur_quarter_no<>v_prev_quarter_no THEN 
					    v_quarter_no:=v_quarter_no+1;
					   v_prev_quarter_no:=v_cur_quarter_no;
					END IF;

 stmt2:='UPDATE ' ||v_schema_name||'.D_DATE SET WEEK_NO = :v1 ,WEEK_NO_ISO = :v2 , MONTH_NO= :v3, QUARTER_NO=:v4 WHERE PERIOD_START_DATE= :v5';

  EXECUTE IMMEDIATE stmt2 USING v_week_no,v_week_no_iso,v_month_no,v_quarter_no, v_cur_date;
			
					
					END LOOP;
					
					CLOSE CS31;
				END;
				
		


END;
/


create or replace PROCEDURE EXTEND_D_DATE (START_YEAR IN INTEGER,END_YEAR IN INTEGER,  SCHEMA_NAME CHAR)

IS
      
      SQLCODE1 INTEGER := 0;
      MESSAGE_TEXT VARCHAR(100);
      RETVAL INTEGER := 0; 
      v_sqlstate CHAR(5) := '00000';
      v_sqlcode INTEGER := 0;
      v_errmsg VARCHAR(100) := '';
      v_total_rows INTEGER;
      v_day_of_week INTEGER := 0;
      v_day_name VARCHAR(20);
      --v_calendar_type INTEGER;
      v_schema_name CHAR(8);
      stmt VARCHAR(1000) := ''; 
      stmt2 VARCHAR(1000) := '';
      v_min_year INTEGER;
      v_max_year INTEGER;
      v_min_date DATE;
      v_max_date DATE;
      v_min_date_c VARCHAR(20);
      v_min_date_v integer :=0;
      v_max_date_v integer :=0;
      v_day_name_c VARCHAR(20);
TYPE CR2 IS REF CURSOR;
CS1 CR2;
CS2 CR2;
CS3 CR2;
CS4 CR2;
	
		BEGIN

		 v_schema_name :=UPPER(RTRIM(SCHEMA_NAME));
      	
     

		IF (START_YEAR IS NULL) OR (START_YEAR>END_YEAR) THEN
    RAISE_APPLICATION_ERROR(-20010,TO_CHAR(VARS_LANG.CRREWMSGE087));
    ROLLBACK;
		END IF;
		
		IF (END_YEAR IS NULL) OR (END_YEAR < START_YEAR) THEN
    RAISE_APPLICATION_ERROR(-20020,TO_CHAR(VARS_LANG.CRREWMSGE088));
    ROLLBACK;
		END IF;
		
--		IF v_calendar_type<>1 AND v_calendar_type <> 2 THEN
--    RAISE_APPLICATION_ERROR(-20030,TO_CHAR(VARS_LANG.CRREWMSGE086));
--    END IF;    
		
		IF (length(rtrim(v_schema_name))=0) THEN
    RAISE_APPLICATION_ERROR(-20040,TO_CHAR(VARS_LANG.CRREWMSGE089));
    ROLLBACK;
		END IF; 
		
		
		 v_min_year:=START_YEAR;
     v_max_year:=END_YEAR;   

	stmt:= 'SELECT COUNT(*) FROM ' || v_schema_name || '.D_DATE ';

					OPEN CS1 FOR stmt;
          Loop 
            FETCH CS1 INTO v_total_rows;
         -- dbms_output.put_line('I am here'||v_total_rows||'space'); 
          EXIT WHEN CS1%NOTFOUND;
          END LOOP;
					CLOSE CS1;


 IF v_total_rows<>0 THEN
   BEGIN
    stmt:='SELECT MIN(PERIOD_START_DATE), MAX(PERIOD_START_DATE) FROM ' || v_schema_name || '.D_DATE';

          OPEN CS2 FOR stmt;
              LOOP
                FETCH CS2 INTO v_min_date,v_max_date;
              
              EXIT WHEN CS2%NOTFOUND;
              END LOOP;  
              CLOSE CS2;
                EXCEPTION
                   WHEN others THEN
                  
          dbms_output.put_line(SubStr('Error '||TO_CHAR(SQLCODE1)||': '||SQLERRM, 1, 255));
    END;       
							  
  IF (to_number(to_char(v_min_date,'dd'))<>1 AND to_number(to_char(v_min_date,'mm'))<>1) THEN
    RAISE_APPLICATION_ERROR(-20041,TO_CHAR(VARS_LANG.CRREWMSGE090));
    ROLLBACK;
  END IF;   
  
 IF (to_number(to_char(v_max_date,'dd'))<>31 AND to_number(to_char(v_max_date,'mm'))<>12) THEN
    RAISE_APPLICATION_ERROR(-20042,TO_CHAR(VARS_LANG.CRREWMSGE091));
    ROLLBACK;
  END IF;
  
  
  
  
  --BEGIN
  -- stmt:='SELECT INT_VALUE FROM CONFIG.SYSCONFIG_INFO WHERE NAME=''CALENDAR_WEEK_TYPE''';
				  -- dbms_output.put_line('I am here no 1'||stmt); 		   
					
       --        OPEN CS4 FOR stmt;
       --       LOOP
       --       		FETCH CS4 INTO v_calendar_type;
        --       
      --        EXIT WHEN CS4%NOTFOUND;
      --        END LOOP;  
      --        CLOSE CS4;
       --         EXCEPTION
       --            WHEN others THEN
                  
      --    dbms_output.put_line(SubStr('Error '||TO_CHAR(SQLCODE1)||': '||SQLERRM, 1, 255));
  --  END;       
               
						    --backward extension
							  IF (to_number(to_char(v_min_date,'yyyy'))> v_min_year) THEN 
							  	IF (to_number(to_char(v_min_date,'yyyy'))> v_max_year) THEN
							  		 RAISE_APPLICATION_ERROR(-20061,TO_CHAR(VARS_LANG.CRREWMSGE093));
                    ROLLBACK;
							  	ELSE
                    v_min_date_v:= to_number(to_char(v_min_date,'yyyy'))-1;
						    --stmt:='EXEC ' ||trim(v_schema_name)||'.POPULATE_D_DATE('||v_min_year||','||v_min_date_v||','||''''||trim(v_schema_name)||''''||')';
             
 EXECUTE IMMEDIATE 'BEGIN '||v_schema_name||'.POPULATE_D_DATE('|| v_min_year||','||v_min_date_v||','''||v_schema_name||'''); END;';
           
        	      END IF;
							END IF;
								
								--FORWARD extension
							  IF (to_number(to_char(v_min_date,'yyyy'))< v_max_year) THEN  
							  	IF (to_number(to_char(v_min_date,'yyyy'))< (v_min_year-1)) THEN
							  	 RAISE_APPLICATION_ERROR(-20062,TO_CHAR(VARS_LANG.CRREWMSGE094));
                  ROLLBACK;
							  ELSE
							     v_max_date_v:=to_number(to_char(v_max_date,'yyyy'))+1;
               
        EXECUTE IMMEDIATE 'BEGIN '||v_schema_name||'.POPULATE_D_DATE('|| v_max_date_v||','||v_max_year||','''||v_schema_name||'''); END;';

        		    END IF;
        		 
							
          END IF;
     EXECUTE IMMEDIATE 'BEGIN '||v_schema_name||'.RECALCULATE_D_DATE('''||v_schema_name||'''); END;';   
     
END IF;
			
END;  			
/



create or replace
FUNCTION SELECT_ETL_DATE 
(ETLGRANULARITY INTEGER,
ETLDATE TIMESTAMP,
CAL_TYPE INTEGER) 
RETURN INTEGER 
AS
      v_date_id  INTEGER  := -1;
	  v_cal_type CHAR(1) := '';
	  stmt       VARCHAR(1000) := ''; 
BEGIN 
	 if CAL_TYPE = 1 then
	   v_cal_type := 'G';
     else
       v_cal_type := 'I';
	 end if;
	 if ETLGRANULARITY = 1 then
	   SELECT DATE_ID into v_date_id FROM D_DATE WHERE PERIOD_START_DATE =to_date(to_char(ETLDATE,'yyyy-mm-dd'),'yyyy-mm-dd');
     end if;
	 if ETLGRANULARITY = 2 then
      if v_cal_type ='I' then 
       SELECT DATE_ID into v_date_id FROM D_week where WEEK_OF_YEAR =  to_number(to_char(ETLDATE,'IW'))
                                                 and   YEAR_OF= to_number(to_char(ETLDATE,'YYYY'));
      else
         SELECT DATE_ID into v_date_id FROM D_week where WEEK_OF_YEAR = WEEKOFYEAR(ETLDATE)
                                                 and   YEAR_OF= to_number(to_char(ETLDATE,'YYYY'));
      end if;
      end if;
     if ETLGRANULARITY = 3 then
       SELECT DATE_ID into v_date_id FROM D_month WHERE MONTH_OF_YEAR=to_number(to_char(ETLDATE, 'MM')) AND YEAR_OF=to_number(to_char(ETLDATE,'YYYY'));
     end if;
     RETURN v_date_id;
END;
/









